# coding: utf-8

"""
    FINBOURNE Notifications API

    FINBOURNE Technology  # noqa: E501

    Contact: info@finbourne.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict
from pydantic.v1 import BaseModel, Field, StrictStr, constr, validator

class AzureServiceBusNotificationType(BaseModel):
    """
    The information required to create or update an Azure Service Bus notification  # noqa: E501
    """
    type: StrictStr = Field(..., description="The type of delivery mechanism for this notification")
    namespace: constr(strict=True, min_length=1) = Field(..., description="Reference to namespace from Configuration Store")
    queue_name: constr(strict=True, min_length=1) = Field(..., alias="queueName", description="Reference to queue name from Configuration Store")
    body: constr(strict=True, max_length=1024, min_length=1) = Field(..., description="The body of the Azure Service Bus Message")
    tenant_id: constr(strict=True, min_length=1) = Field(..., alias="tenantId", description="Reference to tenant id from Configuration Store")
    client_id: constr(strict=True, min_length=1) = Field(..., alias="clientId", description="Reference to client id from Configuration Store")
    client_secret: constr(strict=True, min_length=1) = Field(..., alias="clientSecret", description="Reference to client secret from Configuration Store")
    __properties = ["type", "namespace", "queueName", "body", "tenantId", "clientId", "clientSecret"]

    @validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in ('AzureServiceBus'):
            raise ValueError("must be one of enum values ('AzureServiceBus')")
        return value

    @validator('body')
    def body_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"^[\s\S]*$", value):
            raise ValueError(r"must validate the regular expression /^[\s\S]*$/")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> AzureServiceBusNotificationType:
        """Create an instance of AzureServiceBusNotificationType from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> AzureServiceBusNotificationType:
        """Create an instance of AzureServiceBusNotificationType from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return AzureServiceBusNotificationType.parse_obj(obj)

        _obj = AzureServiceBusNotificationType.parse_obj({
            "type": obj.get("type"),
            "namespace": obj.get("namespace"),
            "queue_name": obj.get("queueName"),
            "body": obj.get("body"),
            "tenant_id": obj.get("tenantId"),
            "client_id": obj.get("clientId"),
            "client_secret": obj.get("clientSecret")
        })
        return _obj
